diff --git a/src/backend/optimizer/path/joinpath.c b/src/backend/optimizer/path/joinpath.c
index 02a6302..aa3362b 100644
--- a/src/backend/optimizer/path/joinpath.c
+++ b/src/backend/optimizer/path/joinpath.c
@@ -22,6 +22,7 @@
 #include "optimizer/pathnode.h"
 #include "optimizer/paths.h"
 #include "optimizer/planmain.h"
+#include "optimizer/tlist.h"
 
 /* Hook for plugins to get control in add_paths_to_joinrel() */
 set_join_pathlist_hook_type set_join_pathlist_hook = NULL;
@@ -39,6 +40,10 @@ set_join_pathlist_hook_type set_join_pathlist_hook = NULL;
 #define PATH_PARAM_BY_REL(path, rel)	\
 	(PATH_PARAM_BY_REL_SELF(path, rel) || PATH_PARAM_BY_PARENT(path, rel))
 
+#define REL_HAS_GROUPED_PATHS(rel) ((rel)->gpi && (rel)->gpi->pathlist)
+#define REL_HAS_PARTIAL_GROUPED_PATHS(rel) \
+	((rel)->gpi && (rel)->gpi->partial_pathlist)
+
 static void try_partial_mergejoin_path(PlannerInfo *root,
 						   RelOptInfo *joinrel,
 						   Path *outer_path,
@@ -48,10 +53,21 @@ static void try_partial_mergejoin_path(PlannerInfo *root,
 						   List *outersortkeys,
 						   List *innersortkeys,
 						   JoinType jointype,
-						   JoinPathExtraData *extra);
+						   JoinPathExtraData *extra,
+						   bool grouped,
+						   bool do_aggregate);
 static void sort_inner_and_outer(PlannerInfo *root, RelOptInfo *joinrel,
 					 RelOptInfo *outerrel, RelOptInfo *innerrel,
 					 JoinType jointype, JoinPathExtraData *extra);
+static void sort_inner_and_outer_common(PlannerInfo *root,
+							RelOptInfo *joinrel,
+							RelOptInfo *outerrel,
+							RelOptInfo *innerrel,
+							JoinType jointype,
+							JoinPathExtraData *extra,
+							bool grouped_outer,
+							bool grouped_inner,
+							bool do_aggregate);
 static void match_unsorted_outer(PlannerInfo *root, RelOptInfo *joinrel,
 					 RelOptInfo *outerrel, RelOptInfo *innerrel,
 					 JoinType jointype, JoinPathExtraData *extra);
@@ -60,14 +76,17 @@ static void consider_parallel_nestloop(PlannerInfo *root,
 						   RelOptInfo *outerrel,
 						   RelOptInfo *innerrel,
 						   JoinType jointype,
-						   JoinPathExtraData *extra);
+						   JoinPathExtraData *extra,
+						   bool grouped, bool do_aggregate);
 static void consider_parallel_mergejoin(PlannerInfo *root,
 							RelOptInfo *joinrel,
 							RelOptInfo *outerrel,
 							RelOptInfo *innerrel,
 							JoinType jointype,
 							JoinPathExtraData *extra,
-							Path *inner_cheapest_total);
+							Path *inner_cheapest_total,
+							bool grouped_outer,
+							bool do_aggregate);
 static void hash_inner_and_outer(PlannerInfo *root, RelOptInfo *joinrel,
 					 RelOptInfo *outerrel, RelOptInfo *innerrel,
 					 JoinType jointype, JoinPathExtraData *extra);
@@ -87,7 +106,10 @@ static void generate_mergejoin_paths(PlannerInfo *root,
 						 bool useallclauses,
 						 Path *inner_cheapest_total,
 						 List *merge_pathkeys,
-						 bool is_partial);
+						 bool is_partial,
+						 bool grouped_outer,
+						 bool grouped_inner,
+						 bool do_aggregate);
 
 
 /*
@@ -302,8 +324,8 @@ add_paths_to_joinrel(PlannerInfo *root,
 	 * joins, because there may be no other alternative.
 	 */
 	if (enable_hashjoin || jointype == JOIN_FULL)
-		hash_inner_and_outer(root, joinrel, outerrel, innerrel,
-							 jointype, &extra);
+		hash_inner_and_outer(root, joinrel, outerrel, innerrel, jointype,
+							 &extra);
 
 	/*
 	 * 5. If inner and outer relations are foreign tables (or joins) belonging
@@ -312,9 +334,15 @@ add_paths_to_joinrel(PlannerInfo *root,
 	 */
 	if (joinrel->fdwroutine &&
 		joinrel->fdwroutine->GetForeignJoinPaths)
+	{
 		joinrel->fdwroutine->GetForeignJoinPaths(root, joinrel,
 												 outerrel, innerrel,
-												 jointype, &extra);
+												 jointype, &extra, false);
+		if (joinrel->gpi != NULL && joinrel->gpi->target != NULL)
+			joinrel->fdwroutine->GetForeignJoinPaths(root, joinrel,
+													 outerrel, innerrel,
+													 jointype, &extra, true);
+	}
 
 	/*
 	 * 6. Finally, give extensions a chance to manipulate the path list.
@@ -364,7 +392,9 @@ try_nestloop_path(PlannerInfo *root,
 				  Path *inner_path,
 				  List *pathkeys,
 				  JoinType jointype,
-				  JoinPathExtraData *extra)
+				  JoinPathExtraData *extra,
+				  bool grouped,
+				  bool do_aggregate)
 {
 	Relids		required_outer;
 	JoinCostWorkspace workspace;
@@ -374,6 +404,20 @@ try_nestloop_path(PlannerInfo *root,
 	Relids		outerrelids;
 	Relids		inner_paramrels = PATH_REQ_OUTER(inner_path);
 	Relids		outer_paramrels = PATH_REQ_OUTER(outer_path);
+	Path	   *join_path;
+	PathTarget *join_target;
+
+	/* Caller should not request aggregation w/o grouped output. */
+	Assert(!do_aggregate || grouped);
+
+	/* GroupedPathInfo is necessary for us to produce a grouped set. */
+	Assert(joinrel->gpi || !grouped);
+
+	/*
+	 * Aggregation target is necessary to produce grouped join output.
+	 */
+	Assert((joinrel->gpi && joinrel->gpi->target) || !grouped ||
+		   !do_aggregate);
 
 	/*
 	 * Paths are parameterized by top-level parents, so run parameterization
@@ -420,42 +464,62 @@ try_nestloop_path(PlannerInfo *root,
 	initial_cost_nestloop(root, &workspace, jointype,
 						  outer_path, inner_path, extra);
 
-	if (add_path_precheck(joinrel,
-						  workspace.startup_cost, workspace.total_cost,
-						  pathkeys, required_outer))
+	/*
+	 * Determine which target the join should produce.
+	 *
+	 * In the case of explicit aggregation, output of the join itself is
+	 * plain.
+	 */
+	if (!grouped || do_aggregate)
+		join_target = joinrel->reltarget;
+	else
+		join_target = joinrel->gpi->target;
+
+	/*
+	 * If the inner path is parameterized, it is parameterized by the topmost
+	 * parent of the outer rel, not the outer rel itself.  Fix that.
+	 */
+	if (PATH_PARAM_BY_PARENT(inner_path, outer_path->parent))
 	{
+		inner_path = reparameterize_path_by_child(root, inner_path,
+												  outer_path->parent);
+
 		/*
-		 * If the inner path is parameterized, it is parameterized by the
-		 * topmost parent of the outer rel, not the outer rel itself.  Fix
-		 * that.
+		 * If we could not translate the path, we can't create nest loop path.
 		 */
-		if (PATH_PARAM_BY_PARENT(inner_path, outer_path->parent))
+		if (!inner_path)
 		{
-			inner_path = reparameterize_path_by_child(root, inner_path,
-													  outer_path->parent);
-
-			/*
-			 * If we could not translate the path, we can't create nest loop
-			 * path.
-			 */
-			if (!inner_path)
-			{
-				bms_free(required_outer);
-				return;
-			}
+			bms_free(required_outer);
+			return;
 		}
+	}
 
-		add_path(joinrel, (Path *)
-				 create_nestloop_path(root,
-									  joinrel,
-									  jointype,
-									  &workspace,
-									  extra,
-									  outer_path,
-									  inner_path,
-									  extra->restrictlist,
-									  pathkeys,
-									  required_outer));
+	join_path = (Path *) create_nestloop_path(root, joinrel, jointype,
+											  &workspace, extra,
+											  outer_path, inner_path,
+											  extra->restrictlist, pathkeys,
+											  required_outer, join_target);
+
+	/* Do partial aggregation if needed. */
+	if (do_aggregate && required_outer == NULL)
+	{
+		create_grouped_path(root, joinrel, join_path, true, false,
+							AGG_HASHED);
+		create_grouped_path(root, joinrel, join_path, true, false,
+							AGG_SORTED);
+	}
+	else if (add_path_precheck(joinrel,
+							   workspace.startup_cost, workspace.total_cost,
+							   pathkeys, required_outer, grouped))
+	{
+		/*
+		 * For a grouped path try to identify unique keys, to possibly avoid
+		 * final aggregation.
+		 */
+		if (grouped)
+			make_uniquekeys(root, (Path *) join_path);
+
+		add_path(joinrel, join_path, grouped);
 	}
 	else
 	{
@@ -476,9 +540,19 @@ try_partial_nestloop_path(PlannerInfo *root,
 						  Path *inner_path,
 						  List *pathkeys,
 						  JoinType jointype,
-						  JoinPathExtraData *extra)
+						  JoinPathExtraData *extra,
+						  bool grouped,
+						  bool do_aggregate)
 {
 	JoinCostWorkspace workspace;
+	Path	   *join_path;
+	PathTarget *join_target;
+
+	/* The same checks we do in try_nestloop_path. */
+	Assert(!do_aggregate || grouped);
+	Assert(joinrel->gpi || !grouped);
+	Assert((joinrel->gpi && joinrel->gpi->target) || !grouped ||
+		   !do_aggregate);
 
 	/*
 	 * If the inner path is parameterized, the parameterization must be fully
@@ -513,7 +587,62 @@ try_partial_nestloop_path(PlannerInfo *root,
 	 */
 	initial_cost_nestloop(root, &workspace, jointype,
 						  outer_path, inner_path, extra);
-	if (!add_partial_path_precheck(joinrel, workspace.total_cost, pathkeys))
+
+	/*
+	 * Determine which target the join should produce.
+	 *
+	 * In the case of explicit aggregation, output of the join itself is
+	 * plain.
+	 */
+	if (!grouped || do_aggregate)
+		join_target = joinrel->reltarget;
+	else
+	{
+		Assert(joinrel->gpi != NULL);
+		join_target = joinrel->gpi->target;
+	}
+
+	join_path = (Path *) create_nestloop_path(root, joinrel, jointype,
+											  &workspace, extra,
+											  outer_path, inner_path,
+											  extra->restrictlist, pathkeys,
+											  NULL, join_target);
+
+	if (do_aggregate)
+	{
+		create_grouped_path(root, joinrel, join_path, true, true, AGG_HASHED);
+		create_grouped_path(root, joinrel, join_path, true, true, AGG_SORTED);
+	}
+	else if (add_partial_path_precheck(joinrel, workspace.total_cost,
+									   pathkeys, grouped))
+	{
+		/* Might be good enough to be worth trying, so let's try it. */
+		add_partial_path(joinrel, (Path *) join_path, grouped);
+	}
+}
+
+static void
+try_grouped_nestloop_path(PlannerInfo *root,
+						  RelOptInfo *joinrel,
+						  Path *outer_path,
+						  Path *inner_path,
+						  List *pathkeys,
+						  JoinType jointype,
+						  JoinPathExtraData *extra,
+						  bool partial,
+						  bool do_aggregate)
+{
+	/*
+	 * Missing GroupedPathInfo indicates that we should not try to create a
+	 * grouped join.
+	 */
+	if (joinrel->gpi == NULL)
+		return;
+
+	/*
+	 * Can't preform explicit aggregation w/o the appropriate target.
+	 */
+	if (do_aggregate && joinrel->gpi->target == NULL)
 		return;
 
 	/*
@@ -532,18 +661,75 @@ try_partial_nestloop_path(PlannerInfo *root,
 			return;
 	}
 
-	/* Might be good enough to be worth trying, so let's try it. */
-	add_partial_path(joinrel, (Path *)
-					 create_nestloop_path(root,
-										  joinrel,
-										  jointype,
-										  &workspace,
-										  extra,
-										  outer_path,
-										  inner_path,
-										  extra->restrictlist,
-										  pathkeys,
-										  NULL));
+	if (!partial)
+		try_nestloop_path(root, joinrel, outer_path, inner_path, pathkeys,
+						  jointype, extra, true, do_aggregate);
+	else
+		try_partial_nestloop_path(root, joinrel, outer_path, inner_path,
+								  pathkeys, jointype, extra, true,
+								  do_aggregate);
+}
+
+static void
+try_nestloop_path_common(PlannerInfo *root,
+						 RelOptInfo *joinrel,
+						 Path *outer_path,
+						 Path *inner_path,
+						 List *pathkeys,
+						 JoinType jointype,
+						 JoinPathExtraData *extra,
+						 bool partial,
+						 bool grouped_outer,
+						 bool grouped_inner,
+						 bool do_aggregate)
+{
+	bool		grouped_join;
+
+	grouped_join = grouped_outer || grouped_inner || do_aggregate;
+
+	/* Join of two grouped paths is not supported. */
+	Assert(!(grouped_outer && grouped_inner));
+
+	if (!grouped_join)
+	{
+		/* Only join plain paths. */
+		if (!partial)
+			try_nestloop_path(root,
+							  joinrel,
+							  outer_path,
+							  inner_path,
+							  pathkeys,
+							  jointype,
+							  extra,
+							  grouped_join,
+							  do_aggregate);
+		else
+			try_partial_nestloop_path(root,
+									  joinrel,
+									  outer_path,
+									  inner_path,
+									  pathkeys,
+									  jointype,
+									  extra,
+									  grouped_join,
+									  do_aggregate);
+	}
+	else
+	{
+		/*
+		 * Either exactly one of the input paths should be grouped, or no one
+		 * is grouped and do_aggregate is true.
+		 */
+		try_grouped_nestloop_path(root,
+								  joinrel,
+								  outer_path,
+								  inner_path,
+								  pathkeys,
+								  jointype,
+								  extra,
+								  partial,
+								  do_aggregate);
+	}
 }
 
 /*
@@ -562,38 +748,39 @@ try_mergejoin_path(PlannerInfo *root,
 				   List *innersortkeys,
 				   JoinType jointype,
 				   JoinPathExtraData *extra,
-				   bool is_partial)
+				   bool grouped,
+				   bool do_aggregate)
 {
 	Relids		required_outer;
 	JoinCostWorkspace workspace;
+	Path	   *join_path;
+	PathTarget *join_target;
 
-	if (is_partial)
-	{
-		try_partial_mergejoin_path(root,
-								   joinrel,
-								   outer_path,
-								   inner_path,
-								   pathkeys,
-								   mergeclauses,
-								   outersortkeys,
-								   innersortkeys,
-								   jointype,
-								   extra);
-		return;
-	}
+	/* Caller should not request aggregation w/o grouped output. */
+	Assert(!do_aggregate || grouped);
+
+	/* GroupedPathInfo is necessary for us to produce a grouped set. */
+	Assert(joinrel->gpi || !grouped);
+
+	/*
+	 * Aggregation target is necessary to produce grouped join output.
+	 */
+	Assert((joinrel->gpi && joinrel->gpi->target) || !grouped ||
+		   !do_aggregate);
 
 	/*
 	 * Check to see if proposed path is still parameterized, and reject if the
 	 * parameterization wouldn't be sensible.
 	 */
-	required_outer = calc_non_nestloop_required_outer(outer_path,
-													  inner_path);
-	if (required_outer &&
-		!bms_overlap(required_outer, extra->param_source_rels))
+	required_outer = calc_non_nestloop_required_outer(outer_path, inner_path);
+	if (required_outer)
 	{
-		/* Waste no memory when we reject a path here */
-		bms_free(required_outer);
-		return;
+		if (!bms_overlap(required_outer, extra->param_source_rels))
+		{
+			/* Waste no memory when we reject a path here */
+			bms_free(required_outer);
+			return;
+		}
 	}
 
 	/*
@@ -612,27 +799,54 @@ try_mergejoin_path(PlannerInfo *root,
 	 */
 	initial_cost_mergejoin(root, &workspace, jointype, mergeclauses,
 						   outer_path, inner_path,
-						   outersortkeys, innersortkeys,
-						   extra);
+						   outersortkeys, innersortkeys, extra);
 
-	if (add_path_precheck(joinrel,
-						  workspace.startup_cost, workspace.total_cost,
-						  pathkeys, required_outer))
+	/*
+	 * Determine which target the join should produce.
+	 *
+	 * In the case of explicit aggregation, output of the join itself is
+	 * plain.
+	 */
+	if (!grouped || do_aggregate)
+		join_target = joinrel->reltarget;
+	else
+		join_target = joinrel->gpi->target;
+
+	join_path = (Path *) create_mergejoin_path(root,
+											   joinrel,
+											   jointype,
+											   &workspace,
+											   extra,
+											   outer_path,
+											   inner_path,
+											   extra->restrictlist,
+											   pathkeys,
+											   required_outer,
+											   mergeclauses,
+											   outersortkeys,
+											   innersortkeys,
+											   join_target);
+
+	/* Do partial aggregation if needed. */
+	if (do_aggregate)
 	{
-		add_path(joinrel, (Path *)
-				 create_mergejoin_path(root,
-									   joinrel,
-									   jointype,
-									   &workspace,
-									   extra,
-									   outer_path,
-									   inner_path,
-									   extra->restrictlist,
-									   pathkeys,
-									   required_outer,
-									   mergeclauses,
-									   outersortkeys,
-									   innersortkeys));
+		create_grouped_path(root, joinrel, join_path, true, false,
+							AGG_HASHED);
+		create_grouped_path(root, joinrel, join_path, true, false,
+							AGG_SORTED);
+	}
+	else if (add_path_precheck(joinrel,
+							   workspace.startup_cost, workspace.total_cost,
+							   pathkeys, required_outer, grouped))
+	{
+		/*
+		 * For a grouped path try to identify unique keys, to possibly avoid
+		 * final aggregation.
+		 */
+		if (grouped)
+			make_uniquekeys(root, (Path *) join_path);
+
+		add_path(joinrel, (Path *) join_path, grouped);
 	}
 	else
 	{
@@ -656,9 +870,19 @@ try_partial_mergejoin_path(PlannerInfo *root,
 						   List *outersortkeys,
 						   List *innersortkeys,
 						   JoinType jointype,
-						   JoinPathExtraData *extra)
+						   JoinPathExtraData *extra,
+						   bool grouped,
+						   bool do_aggregate)
 {
 	JoinCostWorkspace workspace;
+	Path	   *join_path;
+	PathTarget *join_target;
+
+	/* The same checks we do in try_mergejoin_path. */
+	Assert(!do_aggregate || grouped);
+	Assert(joinrel->gpi || !grouped);
+	Assert((joinrel->gpi && joinrel->gpi->target) || !grouped ||
+		   !do_aggregate);
 
 	/*
 	 * See comments in try_partial_hashjoin_path().
@@ -688,27 +912,162 @@ try_partial_mergejoin_path(PlannerInfo *root,
 	 */
 	initial_cost_mergejoin(root, &workspace, jointype, mergeclauses,
 						   outer_path, inner_path,
-						   outersortkeys, innersortkeys,
-						   extra);
+						   outersortkeys, innersortkeys, extra);
+
+	/*
+	 * Determine which target the join should produce.
+	 *
+	 * In the case of explicit aggregation, output of the join itself is
+	 * plain.
+	 */
+	if (!grouped || do_aggregate)
+		join_target = joinrel->reltarget;
+	else
+	{
+		Assert(joinrel->gpi != NULL);
+		join_target = joinrel->gpi->target;
+	}
+
+	join_path = (Path *) create_mergejoin_path(root,
+											   joinrel,
+											   jointype,
+											   &workspace,
+											   extra,
+											   outer_path,
+											   inner_path,
+											   extra->restrictlist,
+											   pathkeys,
+											   NULL,
+											   mergeclauses,
+											   outersortkeys,
+											   innersortkeys,
+											   join_target);
+
+	if (do_aggregate)
+	{
+		create_grouped_path(root, joinrel, join_path, true, true, AGG_HASHED);
+		create_grouped_path(root, joinrel, join_path, true, true, AGG_SORTED);
+	}
+	else if (add_partial_path_precheck(joinrel, workspace.total_cost,
+									   pathkeys, grouped))
+	{
+		/* Might be good enough to be worth trying, so let's try it. */
+		add_partial_path(joinrel, (Path *) join_path, grouped);
+	}
+}
+
+static void
+try_grouped_mergejoin_path(PlannerInfo *root,
+						   RelOptInfo *joinrel,
+						   Path *outer_path,
+						   Path *inner_path,
+						   List *pathkeys,
+						   List *mergeclauses,
+						   List *outersortkeys,
+						   List *innersortkeys,
+						   JoinType jointype,
+						   JoinPathExtraData *extra,
+						   bool partial,
+						   bool do_aggregate)
+{
+	/*
+	 * Missing GroupedPathInfo indicates that we should not try to create a
+	 * grouped join.
+	 */
+	if (joinrel->gpi == NULL)
+		return;
 
-	if (!add_partial_path_precheck(joinrel, workspace.total_cost, pathkeys))
+	/*
+	 * Can't preform explicit aggregation w/o the appropriate target.
+	 */
+	if (do_aggregate && joinrel->gpi->target == NULL)
 		return;
 
-	/* Might be good enough to be worth trying, so let's try it. */
-	add_partial_path(joinrel, (Path *)
-					 create_mergejoin_path(root,
-										   joinrel,
-										   jointype,
-										   &workspace,
-										   extra,
-										   outer_path,
-										   inner_path,
-										   extra->restrictlist,
-										   pathkeys,
-										   NULL,
-										   mergeclauses,
-										   outersortkeys,
-										   innersortkeys));
+	if (!partial)
+		try_mergejoin_path(root, joinrel, outer_path, inner_path, pathkeys,
+						   mergeclauses, outersortkeys, innersortkeys,
+						   jointype, extra, true, do_aggregate);
+	else
+		try_partial_mergejoin_path(root, joinrel, outer_path, inner_path,
+								   pathkeys,
+								   mergeclauses, outersortkeys, innersortkeys,
+								   jointype, extra, true, do_aggregate);
+}
+
+/*
+ * Generic front-end to create combinations of full/partial and grouped/plain
+ * merge joins.
+ */
+static void
+try_mergejoin_path_common(PlannerInfo *root,
+						  RelOptInfo *joinrel,
+						  Path *outer_path,
+						  Path *inner_path,
+						  List *pathkeys,
+						  List *mergeclauses,
+						  List *outersortkeys,
+						  List *innersortkeys,
+						  JoinType jointype,
+						  JoinPathExtraData *extra,
+						  bool partial,
+						  bool grouped_outer,
+						  bool grouped_inner,
+						  bool do_aggregate)
+{
+	bool		grouped_join;
+
+	grouped_join = grouped_outer || grouped_inner || do_aggregate;
+
+	/* Join of two grouped paths is not supported. */
+	Assert(!(grouped_outer && grouped_inner));
+
+	if (!grouped_join)
+	{
+		/* Only join plain paths. */
+		if (!partial)
+			try_mergejoin_path(root,
+							   joinrel,
+							   outer_path,
+							   inner_path,
+							   pathkeys,
+							   mergeclauses,
+							   outersortkeys,
+							   innersortkeys,
+							   jointype,
+							   extra,
+							   false, false);
+		else
+			try_partial_mergejoin_path(root,
+									   joinrel,
+									   outer_path,
+									   inner_path,
+									   pathkeys,
+									   mergeclauses,
+									   outersortkeys,
+									   innersortkeys,
+									   jointype,
+									   extra,
+									   false, false);
+	}
+	else
+	{
+		/*
+		 * Either exactly one of the input paths should be grouped, or no one
+		 * is grouped and do_aggregate is true.
+		 */
+		try_grouped_mergejoin_path(root,
+								   joinrel,
+								   outer_path,
+								   inner_path,
+								   pathkeys,
+								   mergeclauses,
+								   outersortkeys,
+								   innersortkeys,
+								   jointype,
+								   extra,
+								   partial,
+								   do_aggregate);
+	}
 }
 
 /*
@@ -723,47 +1082,92 @@ try_hashjoin_path(PlannerInfo *root,
 				  Path *inner_path,
 				  List *hashclauses,
 				  JoinType jointype,
-				  JoinPathExtraData *extra)
+				  JoinPathExtraData *extra,
+				  bool grouped,
+				  bool do_aggregate)
 {
 	Relids		required_outer;
 	JoinCostWorkspace workspace;
+	Path	   *join_path;
+	PathTarget *join_target;
+
+	/* Caller should not request aggregation w/o grouped output. */
+	Assert(!do_aggregate || grouped);
+
+	/* GroupedPathInfo is necessary for us to produce a grouped set. */
+	Assert(joinrel->gpi || !grouped);
+
+	/*
+	 * Aggregation target is necessary to produce grouped join output.
+	 */
+	Assert((joinrel->gpi && joinrel->gpi->target) || !grouped ||
+		   !do_aggregate);
 
 	/*
 	 * Check to see if proposed path is still parameterized, and reject if the
 	 * parameterization wouldn't be sensible.
 	 */
-	required_outer = calc_non_nestloop_required_outer(outer_path,
-													  inner_path);
-	if (required_outer &&
-		!bms_overlap(required_outer, extra->param_source_rels))
+	required_outer = calc_non_nestloop_required_outer(outer_path, inner_path);
+	if (required_outer)
 	{
-		/* Waste no memory when we reject a path here */
-		bms_free(required_outer);
-		return;
+		if (!bms_overlap(required_outer, extra->param_source_rels))
+		{
+			/* Waste no memory when we reject a path here */
+			bms_free(required_outer);
+			return;
+		}
 	}
 
 	/*
 	 * See comments in try_nestloop_path().  Also note that hashjoin paths
 	 * never have any output pathkeys, per comments in create_hashjoin_path.
+	 *
+	 * TODO Need to consider aggregation here?
 	 */
 	initial_cost_hashjoin(root, &workspace, jointype, hashclauses,
 						  outer_path, inner_path, extra);
 
-	if (add_path_precheck(joinrel,
-						  workspace.startup_cost, workspace.total_cost,
-						  NIL, required_outer))
+	/*
+	 * Determine which target the join should produce.
+	 *
+	 * In the case of explicit aggregation, output of the join itself is
+	 * plain.
+	 */
+	if (!grouped || do_aggregate)
+		join_target = joinrel->reltarget;
+	else
+		join_target = joinrel->gpi->target;
+
+	join_path = (Path *) create_hashjoin_path(root, joinrel, jointype,
+											  &workspace,
+											  extra,
+											  outer_path, inner_path,
+											  extra->restrictlist,
+											  required_outer, hashclauses,
+											  join_target);
+
+	/* Do partial aggregation if needed. */
+	if (do_aggregate)
 	{
-		add_path(joinrel, (Path *)
-				 create_hashjoin_path(root,
-									  joinrel,
-									  jointype,
-									  &workspace,
-									  extra,
-									  outer_path,
-									  inner_path,
-									  extra->restrictlist,
-									  required_outer,
-									  hashclauses));
+		/*
+		 * Only AGG_HASHED is suitable here as it does not expect the input
+		 * set to be sorted.
+		 */
+		create_grouped_path(root, joinrel, join_path, true, false,
+							AGG_HASHED);
+	}
+	else if (add_path_precheck(joinrel,
+							   workspace.startup_cost, workspace.total_cost,
+							   NIL, required_outer, grouped))
+	{
+		/*
+		 * For a grouped path try to identify unique keys, to possibly avoid
+		 * final aggregation.
+		 */
+		if (grouped)
+			make_uniquekeys(root, (Path *) join_path);
+
+		add_path(joinrel, (Path *) join_path, grouped);
 	}
 	else
 	{
@@ -784,9 +1188,19 @@ try_partial_hashjoin_path(PlannerInfo *root,
 						  Path *inner_path,
 						  List *hashclauses,
 						  JoinType jointype,
-						  JoinPathExtraData *extra)
+						  JoinPathExtraData *extra,
+						  bool grouped,
+						  bool do_aggregate)
 {
 	JoinCostWorkspace workspace;
+	Path	   *join_path;
+	PathTarget *join_target;
+
+	/* The same checks we do in try_hashjoin_path. */
+	Assert(!do_aggregate || grouped);
+	Assert(joinrel->gpi || !grouped);
+	Assert((joinrel->gpi && joinrel->gpi->target) || !grouped ||
+		   !do_aggregate);
 
 	/*
 	 * If the inner path is parameterized, the parameterization must be fully
@@ -809,23 +1223,154 @@ try_partial_hashjoin_path(PlannerInfo *root,
 	 */
 	initial_cost_hashjoin(root, &workspace, jointype, hashclauses,
 						  outer_path, inner_path, extra);
-	if (!add_partial_path_precheck(joinrel, workspace.total_cost, NIL))
+
+	/*
+	 * Determine which target the join should produce.
+	 *
+	 * In the case of explicit aggregation, output of the join itself is
+	 * plain.
+	 */
+	if (!grouped || do_aggregate)
+		join_target = joinrel->reltarget;
+	else
+	{
+		Assert(joinrel->gpi != NULL);
+		join_target = joinrel->gpi->target;
+	}
+
+	join_path = (Path *) create_hashjoin_path(root, joinrel, jointype,
+											  &workspace,
+											  extra,
+											  outer_path, inner_path,
+											  extra->restrictlist, NULL,
+											  hashclauses, join_target);
+
+	/* Do partial aggregation if needed. */
+	if (do_aggregate)
+	{
+		create_grouped_path(root, joinrel, join_path, true, true, AGG_HASHED);
+	}
+	else if (add_partial_path_precheck(joinrel, workspace.total_cost,
+									   NIL, grouped))
+	{
+		add_partial_path(joinrel, (Path *) join_path, grouped);
+	}
+}
+
+/*
+ * Create a new grouped hash join path by joining a grouped path to plain
+ * (non-grouped) one, or by joining 2 plain relations and applying grouping on
+ * the result.
+ *
+ * Joining of 2 grouped paths is not supported. If a grouped relation A was
+ * joined to grouped relation B, then the grouping of B reduces the number of
+ * times each group of A is appears in the join output. This makes difference
+ * for some aggregates, e.g. sum().
+ *
+ * If do_aggregate is true, neither input rel is grouped so we need to
+ * aggregate the join result explicitly.
+ *
+ * partial argument tells whether the join path should be considered partial.
+ */
+static void
+try_grouped_hashjoin_path(PlannerInfo *root,
+						  RelOptInfo *joinrel,
+						  Path *outer_path,
+						  Path *inner_path,
+						  List *hashclauses,
+						  JoinType jointype,
+						  JoinPathExtraData *extra,
+						  bool partial,
+						  bool do_aggregate
+)
+{
+	/*
+	 * Missing GroupedPathInfo indicates that we should not try to create a
+	 * grouped join.
+	 */
+	if (joinrel->gpi == NULL)
 		return;
 
-	/* Might be good enough to be worth trying, so let's try it. */
-	add_partial_path(joinrel, (Path *)
-					 create_hashjoin_path(root,
-										  joinrel,
-										  jointype,
-										  &workspace,
-										  extra,
-										  outer_path,
-										  inner_path,
-										  extra->restrictlist,
-										  NULL,
-										  hashclauses));
+	/*
+	 * Can't preform explicit aggregation w/o the appropriate target.
+	 */
+	if (do_aggregate && joinrel->gpi->target == NULL)
+		return;
+
+	if (!partial)
+		try_hashjoin_path(root, joinrel, outer_path, inner_path, hashclauses,
+						  jointype, extra, true, do_aggregate);
+	else
+		try_partial_hashjoin_path(root, joinrel, outer_path, inner_path,
+								  hashclauses, jointype, extra, true,
+								  do_aggregate);
+}
+
+/*
+ * Generic front-end to create combinations of full/partial and grouped/plain
+ * hash joins.
+ */
+static void
+try_hashjoin_path_common(PlannerInfo *root,
+						 RelOptInfo *joinrel,
+						 Path *outer_path,
+						 Path *inner_path,
+						 List *hashclauses,
+						 JoinType jointype,
+						 JoinPathExtraData *extra,
+						 bool partial,
+						 bool grouped_outer,
+						 bool grouped_inner,
+						 bool do_aggregate)
+{
+	bool		grouped_join;
+
+	grouped_join = grouped_outer || grouped_inner || do_aggregate;
+
+	/* Join of two grouped paths is not supported. */
+	Assert(!(grouped_outer && grouped_inner));
+
+	if (!grouped_join)
+	{
+		/* Only join plain paths. */
+		if (!partial)
+			try_hashjoin_path(root,
+							  joinrel,
+							  outer_path,
+							  inner_path,
+							  hashclauses,
+							  jointype,
+							  extra,
+							  false, false);
+		else
+			try_partial_hashjoin_path(root,
+									  joinrel,
+									  outer_path,
+									  inner_path,
+									  hashclauses,
+									  jointype,
+									  extra,
+									  false, false);
+	}
+	else
+	{
+		/*
+		 * Either exactly one of the input paths should be grouped, or no one
+		 * is grouped and do_aggregate is true.
+		 */
+		try_grouped_hashjoin_path(root,
+								  joinrel,
+								  outer_path,
+								  inner_path,
+								  hashclauses,
+								  jointype,
+								  extra,
+								  partial,
+								  do_aggregate);
+	}
 }
 
+
 /*
  * clause_sides_match_join
  *	  Determine whether a join clause is of the right form to use in this join.
@@ -876,6 +1421,34 @@ sort_inner_and_outer(PlannerInfo *root,
 					 JoinType jointype,
 					 JoinPathExtraData *extra)
 {
+	/* Plain (non-grouped) join. */
+	sort_inner_and_outer_common(root, joinrel, outerrel, innerrel,
+								jointype, extra, false, false, false);
+
+	/* Use all the supported strategies to generate grouped join. */
+	sort_inner_and_outer_common(root, joinrel, outerrel, innerrel,
+								jointype, extra, true, false, false);
+	sort_inner_and_outer_common(root, joinrel, outerrel, innerrel,
+								jointype, extra, false, true, false);
+	sort_inner_and_outer_common(root, joinrel, outerrel, innerrel,
+								jointype, extra, false, false, true);
+}
+
+/*
+ * TODO As merge_pathkeys shouldn't differ across calls, use a separate
+ * function to derive them and pass them here in a list.
+ */
+static void
+sort_inner_and_outer_common(PlannerInfo *root,
+							RelOptInfo *joinrel,
+							RelOptInfo *outerrel,
+							RelOptInfo *innerrel,
+							JoinType jointype,
+							JoinPathExtraData *extra,
+							bool grouped_outer,
+							bool grouped_inner,
+							bool do_aggregate)
+{
 	JoinType	save_jointype = jointype;
 	Path	   *outer_path;
 	Path	   *inner_path;
@@ -897,8 +1470,25 @@ sort_inner_and_outer(PlannerInfo *root,
 	 * against mergejoins with parameterized inputs; see comments in
 	 * src/backend/optimizer/README.
 	 */
-	outer_path = outerrel->cheapest_total_path;
-	inner_path = innerrel->cheapest_total_path;
+	if (grouped_outer)
+	{
+		if (REL_HAS_GROUPED_PATHS(outerrel))
+			outer_path = linitial(outerrel->gpi->pathlist);
+		else
+			return;
+	}
+	else
+		outer_path = outerrel->cheapest_total_path;
+
+	if (grouped_inner)
+	{
+		if (REL_HAS_GROUPED_PATHS(innerrel))
+			inner_path = linitial(innerrel->gpi->pathlist);
+		else
+			return;
+	}
+	else
+		inner_path = innerrel->cheapest_total_path;
 
 	/*
 	 * If either cheapest-total path is parameterized by the other rel, we
